SystemOrganization addCategory: #ConfigurationOfLisp!

Object subclass: #ConfigurationOfLisp
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfLisp'!

!ConfigurationOfLisp class methodsFor: 'development support' stamp: 'nsh 6/26/2013 23:12'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfLisp class methodsFor: 'private' stamp: 'nsh 6/26/2013 23:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfLisp class methodsFor: 'private' stamp: 'nsh 6/26/2013 23:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfLisp class methodsFor: 'private' stamp: 'nsh 6/26/2013 23:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfLisp class methodsFor: 'metacello tool support' stamp: 'nsh 6/26/2013 23:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfLisp class methodsFor: 'loading' stamp: 'nsh 6/26/2013 23:12'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfLisp class methodsFor: 'loading' stamp: 'nsh 6/26/2013 23:12'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfLisp class methodsFor: 'loading' stamp: 'nsh 6/26/2013 23:12'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfLisp class methodsFor: 'accessing' stamp: 'nsh 6/26/2013 23:12'!
project

	^self new project! !

!ConfigurationOfLisp class methodsFor: 'development support' stamp: 'nsh 6/26/2013 23:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfLisp methodsFor: 'baselines' stamp: 'nsh 6/26/2013 23:16'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #pharo
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://smalltalkhub.com/mc/goonsh/Lisp/main'.
			spec package: 'Lisp' ]! !

!ConfigurationOfLisp methodsFor: 'accessing' stamp: 'nsh 6/26/2013 23:12'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfLisp methodsFor: 'symbolic versions' stamp: 'nsh 6/26/2013 23:15'!
development: spec
	<symbolicVersion: #development>
	spec for: #common version: '1.0'! !

!ConfigurationOfLisp methodsFor: 'accessing' stamp: 'nsh 6/26/2013 23:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfLisp methodsFor: 'symbolic versions' stamp: 'nsh 6/26/2013 23:15'!
stable: spec
	<symbolicVersion: #stable>
	spec for: #common version: '1.0'! !

!ConfigurationOfLisp methodsFor: 'versions' stamp: 'nsh 6/27/2013 00:04'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec description: 'First release'.
			spec author: 'nsh'.
			spec timestamp: '6/26/2013 23:30'.
			spec package: 'Lisp' with: 'Goodies-Lisp-nsh.9' ]! !
